      subroutine error_stop(prog_name, subname, char_string)
      implicit none

      include 'mpif.h'

      character*(*), intent(in) :: prog_name, subname, char_string
      integer mpi_err

      write(*,*) 'Abnormal program termination - calling MPI_Abort'
      write(*,1000) prog_name, subname, char_string
 1000 format('program name:    ',A,/,
     $       'subroutine name: ',A,/,
     $       'error:           ',A)
      call MPI_Abort( MPI_COMM_WORLD, 2, mpi_err)

      stop
      return
      end subroutine error_stop

C     -----------------------------------------------------------

      subroutine error(prog_name, subname, char_string)
      implicit none

      character*(*), intent(in) :: prog_name, subname, char_string

      write(*,*) 'Abnormal program termination'
      write(*,1000) prog_name, subname, char_string
 1000 format('program name:    ',A,/,
     $       'subroutine name: ',A,/,
     $       'error:           ',A)

      stop
      return
      end subroutine error

